﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Shapes;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Forms;

using System.Windows.Xps.Packaging;
using System.IO;

namespace wpf26
{
    public partial class Window1 : Window
    {
        private XpsDocument _xpsDocument;
        private string _fileName;

        public Window1()
        {
            InitializeComponent();

            AddCommandBindings(ApplicationCommands.Open, 
                OpenCommandHandler);

            AddCommandBindings(ApplicationCommands.Close, 
                CloseCommandHandler);
        }

        private void OpenCommandHandler(object sender, 
            ExecutedRoutedEventArgs e)
        {
            OpenFileDialog dig = new OpenFileDialog();            
            dig.InitialDirectory = Directory.GetCurrentDirectory();
            dig.Filter = "Xps Documents (*.xps)|*.xps";
            dig.FilterIndex = 1;
            if (dig.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (_xpsDocument != null)
                    _xpsDocument.Close();
                try
                {
                    _xpsDocument = new XpsDocument(dig.FileName, 
                                       System.IO.FileAccess.Read);
                }
                catch (UnauthorizedAccessException)
                {
                    System.Windows.MessageBox.Show(
                        string.Format("Unable to access {0}", 
                        dig.FileName));
                    return;
                }

                docViewer.Document = 
                    _xpsDocument.GetFixedDocumentSequence();
                _fileName = dig.FileName;
            }
        }

        private void CloseCommandHandler(object sender, 
            ExecutedRoutedEventArgs e)
        {
            this.Close();
        }

        private void AddCommandBindings(
                ICommand command, ExecutedRoutedEventHandler handler)
        {
            CommandBinding cmdBindings = new CommandBinding(command);
            cmdBindings.Executed += handler;
            CommandBindings.Add(cmdBindings);
        }
    }
}
